*** a/src/backend/commands/tablecmds.c
--- b/src/backend/commands/tablecmds.c
***************
*** 6609,6614 **** createForeignKeyTriggers(Relation rel, Constraint *fkconstraint,
--- 7599,7686 ----
  }
  
  /*
+  * After dropping a primary key, we need to adjust the attnotnull flags for all
+  * columns that do not have a NOT NULL constraint.
+  *
+  * rel is the involved relation, "tuple" is the pg_constraint tuple for the
+  * dropped primary key.  pg_con is pg_constraint, suitably locked.
+  */
+ static void
+ fixup_attnotnull(Relation rel, Relation pg_con, HeapTuple pktuple)
+ {
+ 	Relation	pg_attr;
+ 	HeapTuple	contuple;
+ 	SysScanDesc	scan;
+ 	ScanKeyData	key[2];
+ 	List	   *notnulls = NIL;
+ 	List	   *nullables = NIL;
+ 	ListCell   *cell;
+ 	Datum		arrayp;
+ 	bool		isnull;
+ 	Datum	   *keyvals;
+ 	int			nelems;
+ 	int			i;
+ 	HeapTuple	attrtup;
+ 
+ 	pg_attr = heap_open(AttributeRelationId, RowExclusiveLock);
+ 
+ 	ScanKeyInit(&key[0],
+ 				Anum_pg_constraint_conrelid,
+ 				BTEqualStrategyNumber,
+ 				F_OIDEQ,
+ 				ObjectIdGetDatum(RelationGetRelid(rel)));
+ 
+ 	scan = systable_beginscan(pg_con, ConstraintRelidIndexId, true,
+ 							  SnapshotNow, 1, key);
+ 	while (HeapTupleIsValid(contuple = systable_getnext(scan)))
+ 	{
+ 		Form_pg_constraint	conForm = (Form_pg_constraint) GETSTRUCT(contuple);
+ 		AttrNumber		attno;
+ 
+ 		if (conForm->contype != CONSTRAINT_NOTNULL)
+ 			continue;
+ 
+ 		attno = get_constraint_singlecol_attno(contuple);
+ 		notnulls = lappend_int(notnulls, attno);
+ 	}
+ 	systable_endscan(scan);
+ 
+ 	arrayp = SysCacheGetAttr(CONSTROID, pktuple,
+ 							 Anum_pg_constraint_conkey,
+ 							 &isnull);
+ 	if (isnull)
+ 		elog(ERROR, "null conkey found");
+ 
+ 	deconstruct_array(DatumGetArrayTypeP(arrayp), INT2OID, 2, true,
+ 					  's', &keyvals, NULL, &nelems);
+ 	
+ 	/* this could be made a lot faster if necessary ... */
+ 	for (i = 0; i < nelems; i++)
+ 		if (!list_member_int(notnulls, DatumGetInt16(keyvals[i])))
+ 			nullables = lappend_int(nullables, DatumGetInt16(keyvals[i]));
+ 
+ 	foreach(cell, nullables)
+ 	{
+ 		AttrNumber		attr = (AttrNumber) lfirst_int(cell);
+ 		Form_pg_attribute	attrform;
+ 
+ 		attrtup = SearchSysCacheCopy2(ATTNUM,
+ 									  ObjectIdGetDatum(RelationGetRelid(rel)),
+ 									  Int16GetDatum(attr));
+ 		if (!HeapTupleIsValid(attrtup))
+ 			elog(ERROR, "cache lookup failed for attribute %d of relation %u",
+ 				 attr, RelationGetRelid(rel));
+ 		attrform = (Form_pg_attribute) GETSTRUCT(attrtup);
+ 		Assert(attrform->attnotnull == true);
+ 		attrform->attnotnull = false;
+ 		simple_heap_update(pg_attr, &attrtup->t_self, attrtup);
+ 		CatalogUpdateIndexes(pg_attr, attrtup);
+ 	}
+ 
+ 	heap_close(pg_attr, RowExclusiveLock);
+ }
+ 
+ /*
   * ALTER TABLE DROP CONSTRAINT
   *
   * Like DROP COLUMN, we can't use the normal ALTER TABLE recursion mechanism.
***************
*** 6627,6633 **** ATExecDropConstraint(Relation rel, const char *constrName,
  	ScanKeyData key;
  	HeapTuple	tuple;
  	bool		found = false;
! 	bool		is_check_constraint = false;
  
  	/* At top level, permission check was done in ATPrepCmd, else do it */
  	if (recursing)
--- 7699,7705 ----
  	ScanKeyData key;
  	HeapTuple	tuple;
  	bool		found = false;
! 	bool		is_inheritable_constraint = false;
  
  	/* At top level, permission check was done in ATPrepCmd, else do it */
  	if (recursing)
***************
*** 6651,6656 **** ATExecDropConstraint(Relation rel, const char *constrName,
--- 7723,7732 ----
  
  		con = (Form_pg_constraint) GETSTRUCT(tuple);
  
+ 		/* NOT NULL is handled by ALTER TABLE ... DROP/SET NOT NULL */
+ 		if (con->contype == CONSTRAINT_NOTNULL)
+ 			continue;
+ 
  		if (strcmp(NameStr(con->conname), constrName) != 0)
  			continue;
  
***************
*** 6661,6669 **** ATExecDropConstraint(Relation rel, const char *constrName,
  					 errmsg("cannot drop inherited constraint \"%s\" of relation \"%s\"",
  							constrName, RelationGetRelationName(rel))));
  
! 		/* Right now only CHECK constraints can be inherited */
  		if (con->contype == CONSTRAINT_CHECK)
! 			is_check_constraint = true;
  
  		/*
  		 * Perform the actual constraint deletion
--- 7737,7748 ----
  					 errmsg("cannot drop inherited constraint \"%s\" of relation \"%s\"",
  							constrName, RelationGetRelationName(rel))));
  
! 		/*
! 		 * Remember if we see an inheritable constraint.  We only need to
! 		 * handle CHECK constraints, because we rejected NOT NULL ones above.
! 		 */
  		if (con->contype == CONSTRAINT_CHECK)
! 			is_inheritable_constraint = true;
  
  		/*
  		 * Perform the actual constraint deletion
***************
*** 6674,6679 **** ATExecDropConstraint(Relation rel, const char *constrName,
--- 7753,7765 ----
  
  		performDeletion(&conobj, behavior);
  
+ 		/*
+ 		 * If we dropped the primary key, we need to reset the attnotnull
+ 		 * flag for all columns that don't have a NOT NULL constraint.
+ 		 */
+ 		if (con->contype == CONSTRAINT_PRIMARY)
+ 			fixup_attnotnull(rel, conrel, tuple);
+ 
  		found = true;
  	}
  
***************
*** 6703,6709 **** ATExecDropConstraint(Relation rel, const char *constrName,
  	 * routines, we have to do this one level of recursion at a time; we can't
  	 * use find_all_inheritors to do it in one pass.
  	 */
! 	if (is_check_constraint)
  		children = find_inheritance_children(RelationGetRelid(rel), lockmode);
  	else
  		children = NIL;
--- 7789,7795 ----
  	 * routines, we have to do this one level of recursion at a time; we can't
  	 * use find_all_inheritors to do it in one pass.
  	 */
! 	if (is_inheritable_constraint)
  		children = find_inheritance_children(RelationGetRelid(rel), lockmode);
  	else
  		children = NIL;
***************
*** 6732,6738 **** ATExecDropConstraint(Relation rel, const char *constrName,
  
  			con = (Form_pg_constraint) GETSTRUCT(tuple);
  
! 			/* Right now only CHECK constraints can be inherited */
  			if (con->contype != CONSTRAINT_CHECK)
  				continue;
  
--- 7818,7828 ----
  
  			con = (Form_pg_constraint) GETSTRUCT(tuple);
  
! 			/*
! 			 * Besides CHECK constraint we support inheritance of
! 			 * NOT NULL constraints, too. Ignore them here, since they
! 			 * are handled by ALTER TABLE...DROP/SET NOT NULL
! 			 */
  			if (con->contype != CONSTRAINT_CHECK)
  				continue;
  
***************
*** 7540,7545 **** ATPostAlterTypeParse(Oid oldId, char *cmd,
--- 8630,8636 ----
  								tab->subcmds[AT_PASS_OLD_INDEX] =
  									lappend(tab->subcmds[AT_PASS_OLD_INDEX], cmd);
  								break;
+ 							case AT_SetNotNull:
  							case AT_AddConstraint:
  								tab->subcmds[AT_PASS_OLD_CONSTR] =
  									lappend(tab->subcmds[AT_PASS_OLD_CONSTR], cmd);
***************
*** 8325,8330 **** ATExecAddInherit(Relation child_rel, RangeVar *parent, LOCKMODE lockmode)
--- 9416,9422 ----
  	HeapTuple	inheritsTuple;
  	int32		inhseqno;
  	List	   *children;
+ 	List       *child_attnums;
  
  	/*
  	 * A self-exclusive lock is needed here.  See the similar case in
***************
*** 8412,8421 **** ATExecAddInherit(Relation child_rel, RangeVar *parent, LOCKMODE lockmode)
  						RelationGetRelationName(parent_rel))));
  
  	/* Match up the columns and bump attinhcount as needed */
! 	MergeAttributesIntoExisting(child_rel, parent_rel);
  
  	/* Match up the constraints and bump coninhcount as needed */
! 	MergeConstraintsIntoExisting(child_rel, parent_rel);
  
  	/*
  	 * OK, it looks valid.	Make the catalog entries that show inheritance.
--- 9504,9514 ----
  						RelationGetRelationName(parent_rel))));
  
  	/* Match up the columns and bump attinhcount as needed */
! 	child_attnums = NIL;
! 	MergeAttributesIntoExisting(child_rel, parent_rel, &child_attnums);
  
  	/* Match up the constraints and bump coninhcount as needed */
! 	MergeConstraintsIntoExisting(child_rel, parent_rel, child_attnums);
  
  	/*
  	 * OK, it looks valid.	Make the catalog entries that show inheritance.
***************
*** 8491,8497 **** constraints_equivalent(HeapTuple a, HeapTuple b, TupleDesc tupleDesc)
   * the child must be as well. Defaults are not compared, however.
   */
  static void
! MergeAttributesIntoExisting(Relation child_rel, Relation parent_rel)
  {
  	Relation	attrrel;
  	AttrNumber	parent_attno;
--- 9584,9591 ----
   * the child must be as well. Defaults are not compared, however.
   */
  static void
! MergeAttributesIntoExisting(Relation child_rel, Relation parent_rel,
! 							List **attnums_list)
  {
  	Relation	attrrel;
  	AttrNumber	parent_attno;
***************
*** 8547,8552 **** MergeAttributesIntoExisting(Relation child_rel, Relation parent_rel)
--- 9641,9651 ----
  					   attributeName)));
  
  			/*
+ 			 * Record the child's inherited attnum in attnums_list.
+ 			 */
+ 			*attnums_list = lappend_int(*attnums_list, childatt->attnum);
+ 
+ 			/*
  			 * OK, bump the child column's inheritance count.  (If we fail
  			 * later on, this change will just roll back.)
  			 */
***************
*** 8585,8591 **** MergeAttributesIntoExisting(Relation child_rel, Relation parent_rel)
   * a problem though. Even 100 constraints ought not be the end of the world.
   */
  static void
! MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel)
  {
  	Relation	catalog_relation;
  	TupleDesc	tuple_desc;
--- 9684,9691 ----
   * a problem though. Even 100 constraints ought not be the end of the world.
   */
  static void
! MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel,
! 							 List *child_attnums)
  {
  	Relation	catalog_relation;
  	TupleDesc	tuple_desc;
***************
*** 8612,8618 **** MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel)
  		HeapTuple	child_tuple;
  		bool		found = false;
  
! 		if (parent_con->contype != CONSTRAINT_CHECK)
  			continue;
  
  		/* Search for a child constraint matching this one */
--- 9712,9719 ----
  		HeapTuple	child_tuple;
  		bool		found = false;
  
! 		if (parent_con->contype != CONSTRAINT_CHECK
! 			&& parent_con->contype != CONSTRAINT_NOTNULL)
  			continue;
  
  		/* Search for a child constraint matching this one */
***************
*** 8628,8646 **** MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel)
  			Form_pg_constraint child_con = (Form_pg_constraint) GETSTRUCT(child_tuple);
  			HeapTuple	child_copy;
  
! 			if (child_con->contype != CONSTRAINT_CHECK)
! 				continue;
! 
! 			if (strcmp(NameStr(parent_con->conname),
! 					   NameStr(child_con->conname)) != 0)
! 				continue;
! 
! 			if (!constraints_equivalent(parent_tuple, child_tuple, tuple_desc))
! 				ereport(ERROR,
! 						(errcode(ERRCODE_DATATYPE_MISMATCH),
! 						 errmsg("child table \"%s\" has different definition for check constraint \"%s\"",
! 								RelationGetRelationName(child_rel),
! 								NameStr(parent_con->conname))));
  
  			/*
  			 * OK, bump the child constraint's inheritance count.  (If we fail
--- 9729,9775 ----
  			Form_pg_constraint child_con = (Form_pg_constraint) GETSTRUCT(child_tuple);
  			HeapTuple	child_copy;
  
! 			switch(child_con->contype)
! 			{
! 				case CONSTRAINT_CHECK:
! 				{
! 					if (strcmp(NameStr(parent_con->conname),
! 							   NameStr(child_con->conname)) != 0)
! 						continue;
! 
! 					if (!constraints_equivalent(parent_tuple, child_tuple, tuple_desc))
! 						ereport(ERROR,
! 								(errcode(ERRCODE_DATATYPE_MISMATCH),
! 								 errmsg("child table \"%s\" has different definition for check constraint \"%s\"",
! 										RelationGetRelationName(child_rel),
! 										NameStr(parent_con->conname))));
! 					break;
! 				}
! 				case CONSTRAINT_NOTNULL:
! 				{
! 					Datum     arrayp;
! 					Datum    *vals;
! 					int       nelems;
! 					bool      isnull;
! 
! 					if (child_attnums == NIL)
! 						continue;
! 
! 					arrayp = SysCacheGetAttr(CONSTROID, child_tuple,
! 											 Anum_pg_constraint_conkey, &isnull);
! 					/* should not happen */
! 					Assert(!isnull);
! 					deconstruct_array(DatumGetArrayTypeP(arrayp), INT2OID, 2, true,
! 									  's', &vals, NULL, &nelems);
! 					Assert(nelems > 0);
! 
! 					if (!list_member_int(child_attnums, DatumGetInt16(vals[0])))
! 						continue;
! 					break;
! 				}
! 				default:
! 					continue;
! 			}
  
  			/*
  			 * OK, bump the child constraint's inheritance count.  (If we fail
***************
*** 8683,8690 **** MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel)
   * surprise. But at least we'll never surprise by dropping columns someone
   * isn't expecting to be dropped which would actually mean data loss.
   *
!  * coninhcount and conislocal for inherited constraints are adjusted in
!  * exactly the same way.
   */
  static void
  ATExecDropInherit(Relation rel, RangeVar *parent, LOCKMODE lockmode)
--- 9812,9819 ----
   * surprise. But at least we'll never surprise by dropping columns someone
   * isn't expecting to be dropped which would actually mean data loss.
   *
!  * coninhcount and conislocal for inherited CHECK and NOT NULL constraints
!  * are adjusted in exactly the same way.
   */
  static void
  ATExecDropInherit(Relation rel, RangeVar *parent, LOCKMODE lockmode)
***************
*** 8695,8702 **** ATExecDropInherit(Relation rel, RangeVar *parent, LOCKMODE lockmode)
  	ScanKeyData key[3];
  	HeapTuple	inheritsTuple,
  				attributeTuple,
! 				constraintTuple;
! 	List	   *connames;
  	bool		found = false;
  
  	/*
--- 9824,9831 ----
  	ScanKeyData key[3];
  	HeapTuple	inheritsTuple,
  				attributeTuple,
! 		        constraintTuple;
! 	List	   *constraints;
  	bool		found = false;
  
  	/*
***************
*** 8746,8751 **** ATExecDropInherit(Relation rel, RangeVar *parent, LOCKMODE lockmode)
--- 9875,9882 ----
  						RelationGetRelationName(parent_rel),
  						RelationGetRelationName(rel))));
  
+ 	constraints = NIL;
+ 
  	/*
  	 * Search through child columns looking for ones matching parent rel
  	 */
***************
*** 8759,8764 **** ATExecDropInherit(Relation rel, RangeVar *parent, LOCKMODE lockmode)
--- 9890,9896 ----
  	while (HeapTupleIsValid(attributeTuple = systable_getnext(scan)))
  	{
  		Form_pg_attribute att = (Form_pg_attribute) GETSTRUCT(attributeTuple);
+ 		HeapTuple         parentattr_tuple;
  
  		/* Ignore if dropped or not inherited */
  		if (att->attisdropped)
***************
*** 8766,8773 **** ATExecDropInherit(Relation rel, RangeVar *parent, LOCKMODE lockmode)
  		if (att->attinhcount <= 0)
  			continue;
  
! 		if (SearchSysCacheExistsAttName(RelationGetRelid(parent_rel),
! 										NameStr(att->attname)))
  		{
  			/* Decrement inhcount and possibly set islocal to true */
  			HeapTuple	copyTuple = heap_copytuple(attributeTuple);
--- 9898,9907 ----
  		if (att->attinhcount <= 0)
  			continue;
  
! 		parentattr_tuple = SearchSysCacheCopyAttName(RelationGetRelid(parent_rel),
! 													 NameStr(att->attname));
! 
! 		if (HeapTupleIsValid(parentattr_tuple))
  		{
  			/* Decrement inhcount and possibly set islocal to true */
  			HeapTuple	copyTuple = heap_copytuple(attributeTuple);
***************
*** 8780,8795 **** ATExecDropInherit(Relation rel, RangeVar *parent, LOCKMODE lockmode)
  			simple_heap_update(catalogRelation, &copyTuple->t_self, copyTuple);
  			CatalogUpdateIndexes(catalogRelation, copyTuple);
  			heap_freetuple(copyTuple);
  		}
  	}
  	systable_endscan(scan);
  	heap_close(catalogRelation, RowExclusiveLock);
  
  	/*
! 	 * Likewise, find inherited check constraints and disinherit them. To do
! 	 * this, we first need a list of the names of the parent's check
! 	 * constraints.  (We cheat a bit by only checking for name matches,
! 	 * assuming that the expressions will match.)
  	 */
  	catalogRelation = heap_open(ConstraintRelationId, RowExclusiveLock);
  	ScanKeyInit(&key[0],
--- 9914,9931 ----
  			simple_heap_update(catalogRelation, &copyTuple->t_self, copyTuple);
  			CatalogUpdateIndexes(catalogRelation, copyTuple);
  			heap_freetuple(copyTuple);
+ 			heap_freetuple(parentattr_tuple);
  		}
  	}
  	systable_endscan(scan);
  	heap_close(catalogRelation, RowExclusiveLock);
  
  	/*
! 	 * Likewise, find inherited check and NOT NULL constraints and disinherit
! 	 * them. To do this, we first need a list of the names of the parent's
! 	 * check and NOT NULL constraints.  (For check constraints, we cheat a bit
! 	 * by only checking for name matches, assuming that the expressions will
! 	 * match.)
  	 */
  	catalogRelation = heap_open(ConstraintRelationId, RowExclusiveLock);
  	ScanKeyInit(&key[0],
***************
*** 8799,8812 **** ATExecDropInherit(Relation rel, RangeVar *parent, LOCKMODE lockmode)
  	scan = systable_beginscan(catalogRelation, ConstraintRelidIndexId,
  							  true, SnapshotNow, 1, key);
  
- 	connames = NIL;
- 
  	while (HeapTupleIsValid(constraintTuple = systable_getnext(scan)))
  	{
! 		Form_pg_constraint con = (Form_pg_constraint) GETSTRUCT(constraintTuple);
  
  		if (con->contype == CONSTRAINT_CHECK)
! 			connames = lappend(connames, pstrdup(NameStr(con->conname)));
  	}
  
  	systable_endscan(scan);
--- 9935,9963 ----
  	scan = systable_beginscan(catalogRelation, ConstraintRelidIndexId,
  							  true, SnapshotNow, 1, key);
  
  	while (HeapTupleIsValid(constraintTuple = systable_getnext(scan)))
  	{
! 		Form_pg_constraint con = (Form_pg_constraint)
! 			GETSTRUCT(constraintTuple);
  
  		if (con->contype == CONSTRAINT_CHECK)
! 		{
! 			DisinheritConstraintInfo *inhInfo = (DisinheritConstraintInfo *)
! 				palloc(sizeof(DisinheritConstraintInfo));
! 			inhInfo->contype = CONSTRAINT_CHECK;
! 			inhInfo->conname = pstrdup(NameStr(con->conname));
! 			inhInfo->attnum  = 0;
! 			constraints = lappend(constraints, inhInfo);
! 		}
! 		else if (con->contype == CONSTRAINT_NOTNULL)
! 		{
! 			DisinheritConstraintInfo *inhInfo = (DisinheritConstraintInfo *)
! 				palloc(sizeof(DisinheritConstraintInfo));
! 			inhInfo->contype = CONSTRAINT_NOTNULL;
! 			inhInfo->conname = NULL;
! 			inhInfo->attnum = get_constraint_singlecol_attno(constraintTuple);
! 			constraints = lappend(constraints, inhInfo);
! 		}
  	}
  
  	systable_endscan(scan);
***************
*** 8821,8837 **** ATExecDropInherit(Relation rel, RangeVar *parent, LOCKMODE lockmode)
  
  	while (HeapTupleIsValid(constraintTuple = systable_getnext(scan)))
  	{
! 		Form_pg_constraint con = (Form_pg_constraint) GETSTRUCT(constraintTuple);
  		bool		match;
  		ListCell   *lc;
  
! 		if (con->contype != CONSTRAINT_CHECK)
  			continue;
  
  		match = false;
! 		foreach(lc, connames)
  		{
! 			if (strcmp(NameStr(con->conname), (char *) lfirst(lc)) == 0)
  			{
  				match = true;
  				break;
--- 9972,10012 ----
  
  	while (HeapTupleIsValid(constraintTuple = systable_getnext(scan)))
  	{
! 		Form_pg_constraint con;
  		bool		match;
  		ListCell   *lc;
  
! 		con = (Form_pg_constraint) GETSTRUCT(constraintTuple);
! 
! 		if (con->contype != CONSTRAINT_CHECK &&
! 			con->contype != CONSTRAINT_NOTNULL)
  			continue;
  
+ 		/*
+ 		 * We scan through all constraints of the current child relation,
+ 		 * checking for CONSTRAINT_CHECK and CONSTRAINT_NOTNULL occurrences.
+ 		 *
+ 		 * CHECK constraints are assumed to be named equally to in the
+ 		 * relation's ancestor, while NOT NULL constraints always are attached
+ 		 * to a specific column. Check for attnum and adjust the inheritance
+ 		 * information accordingly.
+ 		 */
+ 
  		match = false;
! 		foreach(lc, constraints)
  		{
! 			DisinheritConstraintInfo *inhInfo = (DisinheritConstraintInfo *) lfirst(lc);
! 
! 			if (inhInfo->contype != con->contype)
! 				continue;
! 			if (con->contype == CONSTRAINT_CHECK &&
! 				strcmp(NameStr(con->conname), inhInfo->conname) == 0)
! 			{
! 				match = true;
! 				break;
! 			}
! 			if (con->contype == CONSTRAINT_NOTNULL &&
! 				(get_constraint_singlecol_attno(constraintTuple) == inhInfo->attnum))
  			{
  				match = true;
  				break;
***************
*** 8842,8853 **** ATExecDropInherit(Relation rel, RangeVar *parent, LOCKMODE lockmode)
  		{
  			/* Decrement inhcount and possibly set islocal to true */
  			HeapTuple	copyTuple = heap_copytuple(constraintTuple);
! 			Form_pg_constraint copy_con = (Form_pg_constraint) GETSTRUCT(copyTuple);
  
  			if (copy_con->coninhcount <= 0)		/* shouldn't happen */
  				elog(ERROR, "relation %u has non-inherited constraint \"%s\"",
  					 RelationGetRelid(rel), NameStr(copy_con->conname));
  
  			copy_con->coninhcount--;
  			if (copy_con->coninhcount == 0)
  				copy_con->conislocal = true;
--- 10017,10032 ----
  		{
  			/* Decrement inhcount and possibly set islocal to true */
  			HeapTuple	copyTuple = heap_copytuple(constraintTuple);
! 			Form_pg_constraint copy_con = (Form_pg_constraint)
! 				GETSTRUCT(copyTuple);
  
  			if (copy_con->coninhcount <= 0)		/* shouldn't happen */
  				elog(ERROR, "relation %u has non-inherited constraint \"%s\"",
  					 RelationGetRelid(rel), NameStr(copy_con->conname));
  
+ 			elog(DEBUG1, "disinherit not null constraint \"%s\" relation \"%s\"",
+ 				 NameStr(copy_con->conname), RelationGetRelationName(rel));
+ 
  			copy_con->coninhcount--;
  			if (copy_con->coninhcount == 0)
  				copy_con->conislocal = true;
*** a/src/backend/commands/typecmds.c
--- b/src/backend/commands/typecmds.c
***************
*** 95,101 **** static char *domainAddConstraint(Oid domainOid, Oid domainNamespace,
  					Oid baseTypeOid,
  					int typMod, Constraint *constr,
  					char *domainName);
! 
  
  /*
   * DefineType
--- 95,103 ----
  					Oid baseTypeOid,
  					int typMod, Constraint *constr,
  					char *domainName);
! static void domainAddNotNull(Oid domainOid, Oid domainNamespace,
! 				 Constraint *constr, char *domainName);
! static void domainDropNotNull(Oid domainOid);
  
  /*
   * DefineType
***************
*** 969,978 **** DefineDomain(CreateDomainStmt *stmt)
  				break;
  
  			case CONSTR_NOTNULL:
! 				if (nullDefined && !typNotNull)
! 					ereport(ERROR,
! 							(errcode(ERRCODE_SYNTAX_ERROR),
! 						   errmsg("conflicting NULL/NOT NULL constraints")));
  				typNotNull = true;
  				nullDefined = true;
  				break;
--- 971,995 ----
  				break;
  
  			case CONSTR_NOTNULL:
! 				if (nullDefined) 
! 				{
! 					if (!typNotNull)
! 						ereport(ERROR,
! 								(errcode(ERRCODE_SYNTAX_ERROR),
! 								 errmsg("conflicting NULL/NOT NULL constraints")));
! 					else
! 						ereport(ERROR,
! 								(errcode(ERRCODE_SYNTAX_ERROR),
! 								 errmsg("multiple definitions for NOT NULL constraint")));
! 				}
! 
! 				/*
! 				 * We are going to create a pg_constraint entry for this
! 				 * constraint to record an explicit named NOT NULL constraint.
! 				 * We do this even in case it wasn't named explicitly. Since we
! 				 * need the domain's OID, this is done later.
! 				 */
! 
  				typNotNull = true;
  				nullDefined = true;
  				break;
***************
*** 1080,1089 **** DefineDomain(CreateDomainStmt *stmt)
  	{
  		Constraint *constr = lfirst(listptr);
  
! 		/* it must be a Constraint, per check above */
  
  		switch (constr->contype)
  		{
  			case CONSTR_CHECK:
  				domainAddConstraint(domainoid, domainNamespace,
  									basetypeoid, basetypeMod,
--- 1097,1110 ----
  	{
  		Constraint *constr = lfirst(listptr);
  
! 		/* it must be a CHECK or NOT NULL Constraint, per check above */
  
  		switch (constr->contype)
  		{
+ 			case CONSTR_NOTNULL:
+ 				domainAddNotNull(domainoid, domainNamespace,
+ 								 constr, domainName);
+ 				break;
  			case CONSTR_CHECK:
  				domainAddConstraint(domainoid, domainNamespace,
  									basetypeoid, basetypeMod,
***************
*** 1857,1868 **** AlterDomainNotNull(List *names, bool notNull)
--- 1878,1959 ----
  
  	CatalogUpdateIndexes(typrel, tup);
  
+ 	/* also update pg_constraint */
+ 	if (typTup->typnotnull)
+ 	{
+ 		Constraint constr;
+ 
+ 		/*
+ 		 * ALTER DOMAIN ... SET NOT NULL doesn't have an infrastructure
+ 		 * to specify a name for the new constraint, so always generate
+ 		 * a new one.
+ 		 */
+ 		constr.contype = CONSTR_NOTNULL;
+ 		constr.conname = NULL;
+ 
+ 		domainAddNotNull(domainoid, typTup->typnamespace,
+ 						 &constr, NameStr(typTup->typname));
+ 	}
+ 	else
+ 		domainDropNotNull(domainoid);
+ 
  	/* Clean up */
  	heap_freetuple(tup);
  	heap_close(typrel, RowExclusiveLock);
  }
  
  /*
+  * Subroutine for AlterDomainNotNull
+  *		Delete the pg_constraint entry for a domain's NOT NULL constraint
+  */
+ static void
+ domainDropNotNull(Oid domainOid)
+ {
+ 	Relation conrel;
+ 	HeapTuple contup;
+ 	SysScanDesc conscan;
+ 	ScanKeyData key[1];
+ 
+ 	/* Grab an appropriate lock on the pg_constraint relation */
+ 	conrel = heap_open(ConstraintRelationId, RowExclusiveLock);
+ 
+ 	/* Use the index to scan only constraints of the target relation */
+ 	ScanKeyInit(&key[0],
+ 				Anum_pg_constraint_contypid,
+ 				BTEqualStrategyNumber, F_OIDEQ,
+ 				ObjectIdGetDatum(domainOid));
+ 
+ 	conscan = systable_beginscan(conrel, ConstraintTypidIndexId, true,
+ 								 SnapshotNow, 1, key);
+ 
+ 	while (HeapTupleIsValid(contup = systable_getnext(conscan)))
+ 	{
+ 		Form_pg_constraint con = (Form_pg_constraint) GETSTRUCT(contup);
+ 
+ 		/*
+ 		 * Perform deletion over pg_depend
+ 		 */
+ 		if (con->contype == CONSTRAINT_NOTNULL)
+ 		{
+ 			ObjectAddress conobj;
+ 
+ 			conobj.classId = ConstraintRelationId;
+ 			conobj.objectId = HeapTupleGetOid(contup);
+ 			conobj.objectSubId = 0;
+ 
+ 			performDeletion(&conobj, DROP_RESTRICT);
+ 
+ 			/*
+ 			 * we only expect a single tuple, but keep looping just in case.
+ 			 */
+ 		}
+ 	}
+ 
+ 	systable_endscan(conscan);
+ 	heap_close(conrel, RowExclusiveLock);
+ }
+ 
+ /*
   * AlterDomainDropConstraint
   *
   * Implements the ALTER DOMAIN DROP CONSTRAINT statement
***************
*** 2400,2405 **** checkDomainOwner(HeapTuple tup)
--- 2491,2558 ----
  }
  
  /*
+  * domainAddNotNull
+  *		add a NOT NULL constraint to pg_constraint for a domain.
+  */
+ void
+ domainAddNotNull(Oid domainOid, Oid domainNamespace, Constraint *constr,
+ 				 char *domainName)
+ {
+ 	Assert(constr->contype == CONSTR_NOTNULL);
+ 
+ 	/*
+ 	 * Validate constraint name or assign a new one if not specified already.
+ 	 */
+ 	if (constr->conname)
+ 	{
+ 		if (ConstraintNameIsUsed(CONSTRAINT_DOMAIN,
+ 								 domainOid,
+ 								 domainNamespace,
+ 								 constr->conname))
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_DUPLICATE_OBJECT),
+ 					 errmsg("not null constraint \"%s\" for domain \"%s\" already exists",
+ 							constr->conname, domainName)));
+ 	}
+ 	else
+ 		constr->conname = ChooseConstraintName(domainName,
+ 											   NULL,
+ 											   "not_null",
+ 											   domainNamespace,
+ 											   NIL);
+ 
+ 	/*
+ 	 * Store the not null constraint in pg_constraint
+ 	 */
+ 	CreateConstraintEntry(constr->conname,
+ 						  domainNamespace,
+ 						  CONSTRAINT_NOTNULL,
+ 						  false,	/* Is Deferrable */
+ 						  false,	/* Is Deferred */
+ 						  true,		/* Is Validated */
+ 						  InvalidOid,	/* not a relation constraint */
+ 						  NULL,
+ 						  0,
+ 						  domainOid,	/* domain constraint */
+ 						  InvalidOid,	/* no associated index */
+ 						  InvalidOid,	/* Foreign key fields */
+ 						  NULL,
+ 						  NULL,
+ 						  NULL,
+ 						  NULL,
+ 						  0,
+ 						  ' ',
+ 						  ' ',
+ 						  ' ',
+ 						  NULL, /* not an exclusion constraint */
+ 						  NULL, /* Tree form of check constraint */
+ 						  NULL,	/* Binary form of check constraint */
+ 						  NULL,	/* Source form of check constraint */
+ 						  true, /* is local */
+ 						  0);	/* inhcount */
+ }
+ 
+ /*
   * domainAddConstraint - code shared between CREATE and ALTER DOMAIN
   */
  static char *
*** a/src/backend/nodes/copyfuncs.c
--- b/src/backend/nodes/copyfuncs.c
***************
*** 2305,2310 **** _copyColumnDef(ColumnDef *from)
--- 2305,2311 ----
  	COPY_SCALAR_FIELD(inhcount);
  	COPY_SCALAR_FIELD(is_local);
  	COPY_SCALAR_FIELD(is_not_null);
+ 	COPY_SCALAR_FIELD(is_primary_key);
  	COPY_SCALAR_FIELD(is_from_type);
  	COPY_SCALAR_FIELD(storage);
  	COPY_NODE_FIELD(raw_default);
*** a/src/backend/nodes/equalfuncs.c
--- b/src/backend/nodes/equalfuncs.c
***************
*** 2236,2241 **** _equalColumnDef(ColumnDef *a, ColumnDef *b)
--- 2236,2242 ----
  	COMPARE_SCALAR_FIELD(inhcount);
  	COMPARE_SCALAR_FIELD(is_local);
  	COMPARE_SCALAR_FIELD(is_not_null);
+ 	COMPARE_SCALAR_FIELD(is_primary_key);
  	COMPARE_SCALAR_FIELD(is_from_type);
  	COMPARE_SCALAR_FIELD(storage);
  	COMPARE_NODE_FIELD(raw_default);
*** a/src/backend/nodes/outfuncs.c
--- b/src/backend/nodes/outfuncs.c
***************
*** 2095,2100 **** _outColumnDef(StringInfo str, ColumnDef *node)
--- 2095,2101 ----
  	WRITE_INT_FIELD(inhcount);
  	WRITE_BOOL_FIELD(is_local);
  	WRITE_BOOL_FIELD(is_not_null);
+ 	WRITE_BOOL_FIELD(is_primary_key);
  	WRITE_BOOL_FIELD(is_from_type);
  	WRITE_INT_FIELD(storage);
  	WRITE_NODE_FIELD(raw_default);
*** a/src/backend/parser/gram.y
--- b/src/backend/parser/gram.y
***************
*** 2505,2510 **** columnDef:	ColId Typename ColQualList
--- 2505,2511 ----
  					n->inhcount = 0;
  					n->is_local = true;
  					n->is_not_null = false;
+ 					n->is_primary_key = false;
  					n->is_from_type = false;
  					n->storage = 0;
  					n->raw_default = NULL;
***************
*** 2524,2529 **** columnOptions:	ColId WITH OPTIONS ColQualList
--- 2525,2531 ----
  					n->inhcount = 0;
  					n->is_local = true;
  					n->is_not_null = false;
+ 					n->is_primary_key = false;
  					n->is_from_type = false;
  					n->storage = 0;
  					n->raw_default = NULL;
***************
*** 3045,3050 **** CreateAsElement:
--- 3047,3053 ----
  					n->inhcount = 0;
  					n->is_local = true;
  					n->is_not_null = false;
+ 					n->is_primary_key = false;
  					n->is_from_type = false;
  					n->storage = 0;
  					n->raw_default = NULL;
***************
*** 9171,9176 **** TableFuncElement:	ColId Typename opt_collate_clause
--- 9174,9180 ----
  					n->inhcount = 0;
  					n->is_local = true;
  					n->is_not_null = false;
+ 					n->is_primary_key = false;
  					n->is_from_type = false;
  					n->storage = 0;
  					n->raw_default = NULL;
